//+------------------------------------------------------------------+
//|                                                      two3ea3.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//---- input parameters
extern double    TakeProfit=25000.0;
extern double    Lots=0.1;
extern double    TrailingStop=150.0;
extern bool usestoploss = True;
extern int stoploss = 15;
int  bn=0, cn=0,d=0;
static datetime lastbar;
bool curnum=True;
extern bool bopin=True, sopin=False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   lastbar=Time[1];
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

int Crossed (double line1 , double line2)
   {
      static int last_direction = 0;
      static int current_dirction = 0;
      
      if(line1>line2)current_dirction = 1; //up
      if(line1<line2)current_dirction = 2; //down



      if(current_dirction != last_direction) //changed 
      {
            last_direction = current_dirction;
            return (last_direction);
      }
      else
      {
            return (0);
      }
   } 
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
//---Do every tick stuff here
   
   int cnt, ticket, total;
   double shortEma, longEma, stopllevel;
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
//Do once per bar stuff here     
     
   shortEma = iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,0);
   longEma = iMA(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,0);
   
   int isCrossed  = Crossed (shortEma,longEma);

//if( Hour()<=0 && Hour()<4|| Hour()>=4 && Hour()<8||
//Hour()>=8 && Hour()<12|| Hour()>=12 && Hour()<16||
//Hour()>=16 && Hour()<20|| Hour()>=20 && Hour()<0)
//if(Hour()==0 || Hour()==4 || Hour()==8 || Hour()==12 || Hour()==16 || Hour()==20)
//  {
   if (IsNewBar()) //IsNewBar checks for a new bar and does once per bar stuff
   //curnum sets to true if no order,trade perbar  and is ok to do a trade 
   //it does 1 trade, order per Bar
   //buyopin sets to 1 if a buy opinion and sellopin for a sell opinion, it reverses 
   //buy to sell trades
   {
   
   //Do new bar stuff
//   Print("time", Time[1]); 
   curnum=True;
   }// isnewbar ends here
   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
                if (Low[0]<Close[1]-Close[1]/10000 && curnum==True )
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
               
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);    //Bid-Point*TrailingStop
                    }
               }
              }//ts
           }//if long posn is opened
         else // go to short position
           {
            // should it be closed?
            if( High[0]> Close[1]+Close[1]/10000 && curnum==True)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }//ts
           }//else go to short 
        }//if 
      }//for
      
   total  = OrdersTotal(); 
   if(total < 1) 
   {
   //     if( High[0]> Close[1]+Close[1]*15/1000)
       if( High[0]> Close[1]+Close[1]/10000 && sopin==True && curnum==True)   
        {
        curnum=False;
//        Print("Hello b");
         bopin=True;
         sopin=False;
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-stoploss*Point,Ask+TakeProfit*Point,"My EA",12345,0,Green);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
              }
            else Print("Error opening BUY order : ",GetLastError());
            return(0);
           }          

//              if (Low[0]<Close[1]-Close[1]/100000) Print("hello s");
   
    if (Low[0]<Close[1]-Close[1]/10000 && bopin==True && curnum==True)
         {
         curnum=False;
         bopin=False;
         sopin=True;
         
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+stoploss*Point,Bid-TakeProfit*Point,"My EA",12345,0,Red);
            if(ticket>0)
              {
              
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
              }
               else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }//entry sell
         return(0);
// }//isnewbar whole program    
//}// times equal
 } //if total orders 
   return(0);
   
 }//start   
   bool IsNewBar()
  {
  datetime curbar =Time[0];//Open time of current Bar
  if(lastbar!=curbar)
    {
    lastbar=curbar;
    return(true);
    }
    return(false);
  }    
  //---------------------------------
   
   

